Index: pjproject/trunk/pjsip/include/pjsip/sip_config.h
===================================================================
--- pjproject/trunk/pjsip/include/pjsip/sip_config.h	(revision 514)
+++ pjproject/trunk/pjsip/include/pjsip/sip_config.h	(revision 515)
@@ -20,5 +20,40 @@
 #define __PJSIP_SIP_CONFIG_H__
 
+/**
+ * @file sip_config.h
+ * @brief Compile time configuration.
+ */
 #include <pj/config.h>
+
+/**
+ * @defgroup PJSIP PJSIP Library Collection
+ */
+
+/**
+ * @defgroup PJSIP_CORE Core SIP Library
+ * @ingroup PJSIP
+ * @brief The core framework from which all other SIP components depends on.
+ * 
+ * The PJSIP Core library only provides transport framework, event
+ * dispatching/module framework, and SIP message representation and
+ * parsing. It doesn't do anything usefull in itself!
+ *
+ * If application wants the stack to do anything usefull at all,
+ * it must registers @ref PJSIP_MOD to the core library. Examples
+ * of modules are @ref PJSIP_TRANSACT and @ref PJSUA_UA.
+ */
+
+/**
+ * @defgroup PJSIP_BASE Base Types
+ * @ingroup PJSIP_CORE
+ * @brief Basic PJSIP types and configurations.
+ */
+
+/**
+ * @defgroup PJSIP_CONFIG Compile Time Configuration
+ * @ingroup PJSIP_BASE
+ * @brief PJSIP compile time configurations.
+ * @{
+ */
 
 /**
@@ -74,4 +109,12 @@
 #ifndef PJSIP_MAX_MODULE
 #   define PJSIP_MAX_MODULE		16
+#endif
+
+
+/**
+ * Maximum packet length.
+ */
+#ifndef PJSIP_MAX_PKT_LEN
+#   define PJSIP_MAX_PKT_LEN		1500
 #endif
 
@@ -85,5 +128,4 @@
 /* Transport related constants. */
 
-#define PJSIP_MAX_PKT_LEN		1500
 #define PJSIP_POOL_RDATA_LEN		4000
 #define PJSIP_POOL_RDATA_INC		4000
@@ -142,20 +184,20 @@
 //#define PJSIP_T2_TIMEOUT	60000
 
-/* T1 timeout value. */
+/** Transaction T1 timeout value. */
 #if !defined(PJSIP_T1_TIMEOUT)
 #  define PJSIP_T1_TIMEOUT	500
 #endif
 
-/* T2 timeout value. */
+/** Transaction T2 timeout value. */
 #if !defined(PJSIP_T2_TIMEOUT)
 #  define PJSIP_T2_TIMEOUT	4000
 #endif
 
-/* Completed timer for non-INVITE */
+/** Transaction completed timer for non-INVITE */
 #if !defined(PJSIP_T4_TIMEOUT)
 #  define PJSIP_T4_TIMEOUT	5000
 #endif
 
-/* Completed timer for INVITE */
+/** Transaction completed timer for INVITE */
 #if !defined(PJSIP_TD_TIMEOUT)
 #  define PJSIP_TD_TIMEOUT	32000
@@ -167,5 +209,5 @@
  */
 
-/*
+/**
  * If this flag is set, the stack will keep the Authorization/Proxy-Authorization
  * headers that are sent in a cache. Future requests with the same realm and
@@ -183,5 +225,5 @@
 #endif
 
-/*
+/**
  * If this flag is set, the stack will proactively send Authorization/Proxy-
  * Authorization header for next requests. If next request has the same method
@@ -204,5 +246,5 @@
 #endif
 
-/*
+/**
  * Support qop="auth" directive.
  * This option also requires client to cache the last challenge offered by
@@ -216,4 +258,8 @@
 
 
+/**
+ * @}
+ */
+
 #include <pj/config.h>
 
Index: pjproject/trunk/pjsip/include/pjsip/sip_dialog.h
===================================================================
--- pjproject/trunk/pjsip/include/pjsip/sip_dialog.h	(revision 514)
+++ pjproject/trunk/pjsip/include/pjsip/sip_dialog.h	(revision 515)
@@ -31,4 +31,28 @@
 #include <pj/sock.h>
 #include <pj/assert.h>
+
+
+/**
+ * @defgroup PJSIP_DIALOG Base Dialog
+ * @ingroup PJSIP_UA
+ * @brief The base dialog framework to support dialog usages.
+ * @{
+ *
+ * The base dialog framework provides management for base dialog
+ * properties such as <b>From</b> header, <b>To</b> header, <b>CSeq</b>
+ * sequencing, <b>Call-ID</b> header, <b>Contact</b> header management, 
+ * dialog <b>route-set</b> management, and common <b>authentication</b>. 
+ * This basic dialog functionality will be shared by all <b>dialog
+ * usages</b> of a particular dialog.
+ *
+ * More detailed information is explained in
+ * <A HREF="/docs.htm">PJSIP Developer's Guide</A>
+ * PDF document, and readers are encouraged to read the document to
+ * get the concept behind dialog, dialog usages, and INVITE sessions.
+ *
+ * Application MUST initialize the user agent layer module by calling
+ * #pjsip_ua_init_module() before using any of the dialog API, and link
+ * the application with with <b>pjsip-core</b> library.
+ */
 
 PJ_BEGIN_DECL
@@ -55,5 +79,8 @@
 enum pjsip_dialog_state
 {
+    /** Dialog is not established. */
     PJSIP_DIALOG_STATE_NULL,
+
+    /** Dialog has been established (probably early) */
     PJSIP_DIALOG_STATE_ESTABLISHED,
 };
@@ -87,5 +114,5 @@
     pjsip_endpoint     *endpt;	    /**< Endpoint instance.		    */
 
-    /* The dialog set. */
+    /** The dialog set which this dialog belongs (opaque type). */
     void	       *dlg_set;
 
Index: pjproject/trunk/pjsip/include/pjsip/sip_endpoint.h
===================================================================
--- pjproject/trunk/pjsip/include/pjsip/sip_endpoint.h	(revision 514)
+++ pjproject/trunk/pjsip/include/pjsip/sip_endpoint.h	(revision 515)
@@ -28,16 +28,16 @@
 #include <pjsip/sip_resolve.h>
 
+/**
+ * @defgroup PJSIP_CORE_CORE At the Very Core
+ * @ingroup PJSIP_CORE
+ * @brief The very core of PJSIP.
+ */
+
 PJ_BEGIN_DECL
 
 /**
- * @defgroup PJSIP SIP Stack Core
- * Implementation of core SIP protocol stack processing.
- */
-
-/**
- * @defgroup PJSIP_ENDPT SIP Endpoint
- * @ingroup PJSIP
- * @brief
- * Representation of SIP node instance.
+ * @defgroup PJSIP_ENDPT Endpoint
+ * @ingroup PJSIP_CORE_CORE
+ * @brief The master, owner of all objects
  *
  * SIP Endpoint instance (pjsip_endpoint) can be viewed as the master/owner of
@@ -287,5 +287,5 @@
  * Note: at the moment we don't have implementation of RFC 3263 yet!
  *
- * @param resolver  The resolver engine.
+ * @param endpt	    The endpoint instance.
  * @param pool	    The pool to allocate resolver job.
  * @param target    The target specification to be resolved.
@@ -420,4 +420,9 @@
 
 /**
+ * @}
+ */
+
+
+/**
  * Log an error.
  */
@@ -437,8 +442,4 @@
             } while (0)
 
-/**
- * @}
- */
-
 /*
  * Internal functions.
Index: pjproject/trunk/pjsip/include/pjsip/sip_errno.h
===================================================================
--- pjproject/trunk/pjsip/include/pjsip/sip_errno.h	(revision 514)
+++ pjproject/trunk/pjsip/include/pjsip/sip_errno.h	(revision 515)
@@ -20,7 +20,19 @@
 #define __PJSIP_SIP_ERRNO_H__
 
+/**
+ * @file sip_errno.h
+ * @brief PJSIP Specific Error Code
+ */
+
 #include <pj/errno.h>
 
 PJ_BEGIN_DECL
+
+/**
+ * @defgroup PJSIP_CORE_ERRNO PJSIP Specific Error Code
+ * @ingroup PJSIP_BASE
+ * @brief PJSIP specific error constants.
+ * @{
+ */
 
 /*
@@ -383,3 +395,8 @@
 PJ_END_DECL
 
+
+/**
+ * @}
+ */
+
 #endif	/* __PJSIP_SIP_ERRNO_H__ */
Index: pjproject/trunk/pjsip/include/pjsip/sip_event.h
===================================================================
--- pjproject/trunk/pjsip/include/pjsip/sip_event.h	(revision 514)
+++ pjproject/trunk/pjsip/include/pjsip/sip_event.h	(revision 515)
@@ -28,6 +28,7 @@
 
 /**
- * @defgroup PJSIP_EVENT SIP Event
- * @ingroup PJSIP
+ * @defgroup PJSIP_EVENT Event
+ * @ingroup PJSIP_CORE_CORE
+ * @brief Representation of events as they are distributed among modules.
  * @{
  */
@@ -65,6 +66,5 @@
 
 /**
- * \struct
- * \brief Event descriptor to fully identify a SIP event.
+ * This structure describe event descriptor to fully identify a SIP event.
  *
  * Events are the only way for a lower layer object to inform something
@@ -86,6 +86,6 @@
     pjsip_event_id_e type;
 
-    /*
-     * The event body.
+    /**
+     * The event body as union, which fields depends on the event type.
      * By convention, the first member of each struct in the union must be
      * the pointer which is relevant to the event.
@@ -217,5 +217,5 @@
  * Get the event string from the event ID.
  * @param e the event ID.
- * @notes defined in sip_util.c
+ * @note defined in sip_util.c
  */
 PJ_DEF(const char *) pjsip_event_str(pjsip_event_id_e e);
Index: pjproject/trunk/pjsip/include/pjsip/sip_module.h
===================================================================
--- pjproject/trunk/pjsip/include/pjsip/sip_module.h	(revision 514)
+++ pjproject/trunk/pjsip/include/pjsip/sip_module.h	(revision 515)
@@ -30,14 +30,24 @@
 
 /**
- * @defgroup PJSIP_MOD SIP Modules
- * @ingroup PJSIP
+ * @defgroup PJSIP_MOD Modules
+ * @ingroup PJSIP_CORE_CORE
+ * @brief Modules are the primary means to extend PJSIP!
  * @{
- */
-
-/**
- * Module registration structure, which is passed by the module to the
- * endpoint during the module registration process. This structure enables
- * the endpoint to query the module capability and to further communicate
- * with the module.
+ * Modules are the primary means to extend PJSIP. Without modules, PJSIP
+ * would not know how to handle messages, and will simply discard all
+ * incoming messages.
+ *
+ * Modules are registered by creating and initializing #pjsip_module 
+ * structure, and register the structure to PJSIP with 
+ * #pjsip_endpt_register_module().
+ *
+ * The <A HREF="/docs.htm">PJSIP Developer's Guide</A>
+ * has a thorough discussion on this subject, and readers are encouraged
+ * to read the document for more information.
+ */
+
+/**
+ * The declaration for SIP module. This structure would be passed to
+ * #pjsip_endpt_register_module() to register the module to PJSIP.
  */
 struct pjsip_module
@@ -47,10 +57,14 @@
 
     /**
-     * Module name.
+     * Module name to identify the module.
+     *
+     * This field MUST be initialized before registering the module.
      */
     pj_str_t name;
 
     /**
-     * Module ID.
+     * Module ID. Application must initialize this field with -1 before
+     * registering the module to PJSIP. After the module is registered,
+     * this field will contain a unique ID to identify the module.
      */
     int id;
@@ -60,9 +74,13 @@
      * regard to other modules. Higher number will make the module gets
      * initialized later.
+     *
+     * This field MUST be initialized before registering the module.
      */
     int priority;
 
     /**
-     * Pointer to function to be called to initialize the module.
+     * Optional function to be called to initialize the module. This function
+     * will be called by endpoint during module registration. If the value
+     * is NULL, then it's equal to returning PJ_SUCCESS.
      *
      * @param endpt	The endpoint instance.
@@ -72,5 +90,7 @@
 
     /**
-     * Pointer to function to be called to start the module.
+     * Optional function to be called to start the module. This function
+     * will be called by endpoint during module registration. If the value
+     * is NULL, then it's equal to returning PJ_SUCCESS.
      *
      * @return		Module should return zero to indicate success.
@@ -79,6 +99,8 @@
 
     /**
-     * Pointer to function to be called to deinitialize the module before
-     * it is unloaded.
+     * Optional function to be called to deinitialize the module before
+     * it is unloaded. This function will be called by endpoint during 
+     * module unregistration. If the value is NULL, then it's equal to 
+     * returning PJ_SUCCESS.
      *
      * @return		Module should return PJ_SUCCESS to indicate success.
@@ -87,6 +109,8 @@
 
     /**
-     * Pointer to function to be called to deinitialize the module before
-     * it is unloaded.
+     * Optional function to be called to deinitialize the module before
+     * it is unloaded. This function will be called by endpoint during 
+     * module unregistration. If the value is NULL, then it's equal to 
+     * returning PJ_SUCCESS.
      *
      * @param mod	The module.
@@ -97,5 +121,5 @@
 
     /**
-     * Called to process incoming request.
+     * Optional function to be called to process incoming request message.
      *
      * @param rdata	The incoming message.
@@ -108,5 +132,5 @@
 
     /**
-     * Called to processed incoming response.
+     * Optional function to be called to process incoming response message.
      *
      * @param rdata	The incoming message.
@@ -119,5 +143,6 @@
 
     /**
-     * Called to process outgoing request.
+     * Optional function to be called when transport layer is about to
+     * transmit outgoing request message.
      *
      * @param tdata	The outgoing request message.
@@ -130,5 +155,6 @@
 
     /**
-     * Called to process outgoing response message.
+     * Optional function to be called when transport layer is about to
+     * transmit outgoing response message.
      *
      * @param tdata	The outgoing response message.
@@ -141,6 +167,7 @@
 
     /**
-     * Called when this module is acting as transaction user for the specified
-     * transaction, when the transaction's state has changed.
+     * Optional function to be called when this module is acting as 
+     * transaction user for the specified transaction, when the 
+     * transaction's state has changed.
      *
      * @param tsx	The transaction.
@@ -158,8 +185,27 @@
 enum pjsip_module_priority
 {
+    /** 
+     * This is the priority used by transport layer.
+     */
     PJSIP_MOD_PRIORITY_TRANSPORT_LAYER	= 8,
+
+    /**
+     * This is the priority used by transaction layer.
+     */
     PJSIP_MOD_PRIORITY_TSX_LAYER	= 16,
+
+    /**
+     * This is the priority used by the user agent and proxy layer.
+     */
     PJSIP_MOD_PRIORITY_UA_PROXY_LAYER	= 32,
+
+    /**
+     * This is the priority used by the dialog usages.
+     */
     PJSIP_MOD_PRIORITY_DIALOG_USAGE	= 48,
+
+    /**
+     * This is the recommended priority to be used by applications.
+     */
     PJSIP_MOD_PRIORITY_APPLICATION	= 64,
 };
Index: pjproject/trunk/pjsip/include/pjsip/sip_msg.h
===================================================================
--- pjproject/trunk/pjsip/include/pjsip/sip_msg.h	(revision 514)
+++ pjproject/trunk/pjsip/include/pjsip/sip_msg.h	(revision 515)
@@ -21,5 +21,5 @@
 
 /**
- * @file sip_msg.h
+ * @file pjsip/sip_msg.h
  * @brief SIP Message Structure.
  */
@@ -32,6 +32,7 @@
 
 /**
- * @defgroup PJSIP_MSG SIP Message Structure
- * @ingroup PJSIP
+ * @defgroup PJSIP_MSG Messaging Elements
+ * @ingroup PJSIP_CORE
+ * @brief Various SIP message elements such as methods, headers, URIs, etc.
  * @{
  */
@@ -155,6 +156,6 @@
 ///////////////////////////////////////////////////////////////////////////////
 /** 
- * @defgroup PJSIP_MSG_HDR Header Fields General Structure.
- * @brief General Header Fields Structure.
+ * @defgroup PJSIP_MSG_HDR Header Fields
+ * @brief Declarations for various SIP header fields.
  * @ingroup PJSIP_MSG
  * @{
@@ -462,6 +463,6 @@
 ///////////////////////////////////////////////////////////////////////////////
 /**
- * @addtogroup PJSIP_MSG_MEDIA Media Type
- * @brief Media type definitions and manipulations.
+ * @addtogroup PJSIP_MSG_MEDIA Media/MIME Type
+ * @brief Media/MIME type declaration and manipulations.
  * @ingroup PJSIP_MSG
  * @{
@@ -655,5 +656,5 @@
 /**
  * @defgroup PJSIP_MSG_MSG Message Structure
- * @brief Message structure and operations.
+ * @brief SIP message (request and response) structure and operations.
  * @ingroup PJSIP_MSG
  * @{
@@ -846,7 +847,5 @@
 ///////////////////////////////////////////////////////////////////////////////
 /**
- * @addtogroup PJSIP_MSG_HDR_GEN Header Field: Generic
- * @brief Generic header field which contains header name and value.
- * @ingroup PJSIP_MSG
+ * @addtogroup PJSIP_MSG_HDR
  * @{
  */
@@ -905,15 +904,6 @@
 
 
-/**
- * @}
- */
-
-///////////////////////////////////////////////////////////////////////////////
-/**
- * @addtogroup PJSIP_MSG_HDR_GEN_INT Header Field: Generic Integer
- * @brief Generic header field which contains header name and value.
- * @ingroup PJSIP_MSG
- * @{
- */
+
+///////////////////////////////////////////////////////////////////////////////
 
 /**
@@ -965,24 +955,23 @@
 							    int value );
 
-/**
- * @}
- */
-
-///////////////////////////////////////////////////////////////////////////////
-/**
- * @defgroup PJSIP_MSG_HDR_GENERIC_LIST Header Field: Generic string list.
- * @brief Header with list of strings separated with comma
- * @ingroup PJSIP_MSG
- * @{
- */
+///////////////////////////////////////////////////////////////////////////////
 
 /** Maximum elements in the header array. */
 #define PJSIP_GENERIC_ARRAY_MAX_COUNT	32
 
+/**
+ * Generic array of string header.
+ */
 typedef struct pjsip_generic_array_hdr
 {
+    /** Standard header fields. */
     PJSIP_DECL_HDR_MEMBER(struct pjsip_generic_array_hdr);
-    unsigned	count;					/**< Number of elements. */
-    pj_str_t	values[PJSIP_GENERIC_ARRAY_MAX_COUNT];	/**< Elements.		 */
+
+    /** Number of tags/elements. */
+    unsigned	count;
+
+    /**< Tags/elements. */
+    pj_str_t	values[PJSIP_GENERIC_ARRAY_MAX_COUNT];
+
 } pjsip_generic_array_hdr;
 
@@ -1019,15 +1008,6 @@
 
 
-/**
- * @}
- */
-
-///////////////////////////////////////////////////////////////////////////////
-/**
- * @defgroup PJSIP_MSG_HDR_ACCEPT Header Field: Accept
- * @brief Accept header field.
- * @ingroup PJSIP_MSG
- * @{
- */
+///////////////////////////////////////////////////////////////////////////////
+
 /** Accept header. */
 typedef pjsip_generic_array_hdr pjsip_accept_hdr;
@@ -1062,14 +1042,9 @@
 						  void *mem );
 
-/**
- * @}
- */
-
-///////////////////////////////////////////////////////////////////////////////
-/**
- * @defgroup PJSIP_MSG_HDR_ALLOW Header Field: Allow
- * @brief Allow header field.
- * @ingroup PJSIP_MSG
- * @{
+
+///////////////////////////////////////////////////////////////////////////////
+
+/**
+ * Allow header.
  */
 typedef pjsip_generic_array_hdr pjsip_allow_hdr;
@@ -1103,15 +1078,6 @@
 						void *mem );
 
-/**
- * @}
- */
-
-///////////////////////////////////////////////////////////////////////////////
-/**
- * @defgroup PJSIP_MSG_HDR_CID Header Field: Call-ID
- * @brief Call-ID header field.
- * @ingroup PJSIP_MSG
- * @{
- */
+///////////////////////////////////////////////////////////////////////////////
+
 /**
  * Call-ID header.
@@ -1152,15 +1118,6 @@
 
 
-/**
- * @}
- */
-
-///////////////////////////////////////////////////////////////////////////////
-/**
- * @defgroup PJSIP_MSG_HDR_CLEN Header Field: Content-Length
- * @brief Content-Length header field.
- * @ingroup PJSIP_MSG
- * @{
- */
+
+///////////////////////////////////////////////////////////////////////////////
 /**
  * Content-Length header.
@@ -1198,15 +1155,5 @@
 
 
-/**
- * @}
- */
-
-///////////////////////////////////////////////////////////////////////////////
-/**
- * @defgroup PJSIP_MSG_HDR_CSEQ Header Field: CSeq
- * @brief CSeq header field.
- * @ingroup PJSIP_MSG
- * @{
- */
+///////////////////////////////////////////////////////////////////////////////
 /**
  * CSeq header.
@@ -1244,15 +1191,5 @@
 					      void *mem );
 
-/**
- * @}
- */
-
-///////////////////////////////////////////////////////////////////////////////
-/**
- * @defgroup PJSIP_MSG_HDR_CONTACT Header Field: Contact
- * @brief Contact header field.
- * @ingroup PJSIP_MSG
- * @{
- */
+///////////////////////////////////////////////////////////////////////////////
 /**
  * Contact header.
@@ -1297,15 +1234,6 @@
 						    void *mem );
 
-/**
- * @}
- */
-
-///////////////////////////////////////////////////////////////////////////////
-/**
- * @defgroup PJSIP_MSG_HDR_CTYPE Header Field: Content-Type
- * @brief Content-Type header field.
- * @ingroup PJSIP_MSG
- * @{
- */
+
+///////////////////////////////////////////////////////////////////////////////
 /**
  * Content-Type.
@@ -1343,15 +1271,5 @@
 						void *mem );
 
-/**
- * @}
- */
-
-///////////////////////////////////////////////////////////////////////////////
-/**
- * @defgroup PJSIP_MSG_HDR_EXPIRES Header Field: Expires
- * @brief Expires header field.
- * @ingroup PJSIP_MSG
- * @{
- */
+///////////////////////////////////////////////////////////////////////////////
 /** Expires header. */
 typedef pjsip_generic_int_hdr pjsip_expires_hdr;
@@ -1388,15 +1306,6 @@
 
 
-/**
- * @}
- */
-
-///////////////////////////////////////////////////////////////////////////////
-/**
- * @defgroup PJSIP_MSG_HDR_FROMTO Header Field: From/To
- * @brief From and To header field.
- * @ingroup PJSIP_MSG
- * @{
- */
+
+///////////////////////////////////////////////////////////////////////////////
 /**
  * To or From header.
@@ -1469,6 +1378,6 @@
  * Convert the header to a From header.
  *
- * @param pool	The pool.
- * @return	"From" header.
+ * @param hdr	    The generic from/to header.
+ * @return	    "From" header.
  */
 PJ_DECL(pjsip_from_hdr*) pjsip_fromto_hdr_set_from( pjsip_fromto_hdr *hdr );
@@ -1477,20 +1386,13 @@
  * Convert the header to a To header.
  *
- * @param pool	The pool.
- * @return	"To" header.
+ * @param hdr	    The generic from/to header.
+ * @return	    "To" header.
  */
 PJ_DECL(pjsip_to_hdr*)   pjsip_fromto_hdr_set_to( pjsip_fromto_hdr *hdr );
 
-/**
- * @}
- */
-
-
-///////////////////////////////////////////////////////////////////////////////
-/**
- * @defgroup PJSIP_MSG_HDR_MAX_FORWARDS Header Field: Max-Forwards
- * @brief Max-Forwards header field.
- * @ingroup PJSIP_MSG
- * @{
+
+///////////////////////////////////////////////////////////////////////////////
+/**
+ * Max-Forwards header.
  */
 typedef pjsip_generic_int_hdr pjsip_max_fwd_hdr;
@@ -1526,15 +1428,8 @@
 pjsip_max_fwd_hdr_init( pj_pool_t *pool, void *mem, int value );
 
-/**
- * @}
- */
-
-
-///////////////////////////////////////////////////////////////////////////////
-/**
- * @defgroup PJSIP_MSG_HDR_MIN_EXPIRES Header Field: Min-Expires
- * @brief Min-Expires header field.
- * @ingroup PJSIP_MSG
- * @{
+
+///////////////////////////////////////////////////////////////////////////////
+/**
+ * Min-Expires header.
  */
 typedef pjsip_generic_int_hdr pjsip_min_expires_hdr;
@@ -1571,16 +1466,6 @@
 							    int value );
 
-/**
- * @}
- */
-
-
-///////////////////////////////////////////////////////////////////////////////
-/**
- * @defgroup PJSIP_MSG_HDR_ROUTING Header Field: Record-Route/Route
- * @brief Record-Route and Route header fields.
- * @ingroup PJSIP_MSG
- * @{
- */
+
+///////////////////////////////////////////////////////////////////////////////
 /**
  * Record-Route and Route headers.
@@ -1590,5 +1475,5 @@
     PJSIP_DECL_HDR_MEMBER(struct pjsip_routing_hdr);  /**< Generic header fields. */
     pjsip_name_addr  name_addr;	  /**< The URL in the Route/Record-Route header. */
-    pjsip_param	     other_param; /** Other parameter. */
+    pjsip_param	     other_param; /**< Other parameter. */
 } pjsip_routing_hdr;
 
@@ -1666,14 +1551,7 @@
 PJ_DECL(pjsip_route_hdr*)   pjsip_routing_hdr_set_route( pjsip_routing_hdr *r );
 
-/**
- * @}
- */
-
-///////////////////////////////////////////////////////////////////////////////
-/**
- * @defgroup PJSIP_MSG_HDR_REQUIRE Header Field: Require
- * @brief Require header field.
- * @ingroup PJSIP_MSG
- * @{
+///////////////////////////////////////////////////////////////////////////////
+/**
+ * Require header.
  */
 typedef pjsip_generic_array_hdr pjsip_require_hdr;
@@ -1705,15 +1583,8 @@
 						    void *mem );
 
-/**
- * @}
- */
-
-
-///////////////////////////////////////////////////////////////////////////////
-/**
- * @defgroup PJSIP_MSG_HDR_RETRY_AFTER Header Field: Retry-After
- * @brief Retry-After header field.
- * @ingroup PJSIP_MSG
- * @{
+
+///////////////////////////////////////////////////////////////////////////////
+/**
+ * Retry-After header.
  */
 typedef pjsip_generic_int_hdr pjsip_retry_after_hdr;
@@ -1745,14 +1616,7 @@
 
 
-/**
- * @}
- */
-
-///////////////////////////////////////////////////////////////////////////////
-/**
- * @defgroup PJSIP_MSG_HDR_SUPPORTED Header Field: Supported
- * @brief Supported header field.
- * @ingroup PJSIP_MSG
- * @{
+///////////////////////////////////////////////////////////////////////////////
+/**
+ * Supported header.
  */
 typedef pjsip_generic_array_hdr pjsip_supported_hdr;
@@ -1779,14 +1643,7 @@
 							void *mem );
 
-/**
- * @}
- */
-
-///////////////////////////////////////////////////////////////////////////////
-/**
- * @defgroup PJSIP_MSG_HDR_UNSUPPORTED Header Field: Unsupported
- * @brief Unsupported header field.
- * @ingroup PJSIP_MSG
- * @{
+///////////////////////////////////////////////////////////////////////////////
+/**
+ * Unsupported header.
  */
 typedef pjsip_generic_array_hdr pjsip_unsupported_hdr;
@@ -1813,16 +1670,5 @@
 							    void *mem );
 
-/**
- * @}
- */
-
-
-///////////////////////////////////////////////////////////////////////////////
-/**
- * @defgroup PJSIP_MSG_HDR_VIA Header Field: Via
- * @brief Via header field.
- * @ingroup PJSIP_MSG
- * @{
- */
+///////////////////////////////////////////////////////////////////////////////
 /**
  * SIP Via header.
@@ -1866,16 +1712,5 @@
 					    void *mem );
 
-/**
- * @}
- */
-
-
-///////////////////////////////////////////////////////////////////////////////
-/**
- * @defgroup PJSIP_MSG_HDR_WARNING Header Field: Warning
- * @brief Warning header field.
- * @ingroup PJSIP_MSG
- * @{
- */
+///////////////////////////////////////////////////////////////////////////////
 /**
  * SIP Warning header.
@@ -1918,23 +1753,5 @@
 				      pj_status_t status);
 
-/**
- * @}
- */
-
-/**
- * @bug Once a header is put in the message, the header CAN NOT be put in
- *      other list. Solution:
- *	- always clone header in the message.
- *	- create a list node for each header in the message.
- */
-
-
-///////////////////////////////////////////////////////////////////////////////
-/**
- * @defgroup PJSIP_MSG_HDR_UNIMP Unimplemented Header Fields
- * @brief Unimplemented header fields.
- * @ingroup PJSIP_MSG
- * @{
- */
+///////////////////////////////////////////////////////////////////////////////
 /** Accept-Encoding header. */
 typedef pjsip_generic_string_hdr pjsip_accept_encoding_hdr;
Index: pjproject/trunk/pjsip/include/pjsip/sip_parser.h
===================================================================
--- pjproject/trunk/pjsip/include/pjsip/sip_parser.h	(revision 514)
+++ pjproject/trunk/pjsip/include/pjsip/sip_parser.h	(revision 515)
@@ -32,6 +32,7 @@
 
 /**
- * @defgroup PJSIP_PARSER SIP Message Parser
- * @ingroup PJSIP
+ * @defgroup PJSIP_PARSER Parser
+ * @ingroup PJSIP_MSG
+ * @brief Message and message elements parsing.
  * @{
  */
@@ -67,4 +68,5 @@
 typedef struct pjsip_parser_err_report
 {
+    /** Standard header fields. */
     PJ_DECL_LIST_MEMBER(struct pjsip_parser_err_report);
     int		except_code;	/**< Error exception (e.g. PJSIP_SYN_ERR_EXCEPTION) */
@@ -135,4 +137,5 @@
  * @param hname		The header name registered.
  * @param hshortname	The short header name registered, or NULL.
+ * @param fptr		Previously registered function to parse the header.
  *
  * @return		zero if unregistration was successfull.
@@ -186,5 +189,5 @@
 PJ_DECL(pjsip_uri*) pjsip_parse_uri( pj_pool_t *pool, 
 				     char *buf, pj_size_t size,
-				     unsigned option);
+				     unsigned options);
 
 /**
@@ -238,4 +241,5 @@
  * @param buf		The input buffer, which must be NULL terminated.
  * @param size		The buffer size.
+ * @param is_datagram	Put non-zero if transport is datagram oriented.
  * @param msg_size	[out] If message is valid, this parameter will contain
  *			the size of the SIP message (including body, if any).
@@ -279,15 +283,22 @@
  * however is optional for the last header.
  *
- * @param pool the pool.
- * @param buf the input text to parse.
- * @param size the text length.
- * @param hlist the header list to store the parsed headers. This list must
- *              have been initialized before calling this function.
- * @return zero if successfull, or -1 if error is encountered. Upon error,
- *              the \a hlist argument MAY contain successfully parsed headers.
+ * @param pool		the pool.
+ * @param input		the input text to parse.
+ * @param size		the text length.
+ * @param hlist		the header list to store the parsed headers. 
+ *			This list must have been initialized before calling 
+ *			this function.
+ * @return		zero if successfull, or -1 if error is encountered. 
+ *			Upon error, the \a hlist argument MAY contain 
+ *			successfully parsed headers.
  */
 PJ_DECL(pj_status_t) pjsip_parse_headers( pj_pool_t *pool,
 					  char *input, pj_size_t size,
 					  pj_list *hlist );
+
+
+/**
+ * @}
+ */
 
 
@@ -317,18 +328,20 @@
  * Various string constants.
  */
-extern const pj_str_t pjsip_USER_STR,
-		      pjsip_METHOD_STR,
-		      pjsip_TRANSPORT_STR,
-		      pjsip_MADDR_STR,
-		      pjsip_LR_STR,
-		      pjsip_SIP_STR,
-		      pjsip_SIPS_STR,
-		      pjsip_TEL_STR,
-		      pjsip_BRANCH_STR,
-		      pjsip_TTL_STR,
-		      pjsip_PNAME_STR,
-		      pjsip_Q_STR,
-		      pjsip_EXPIRES_STR,
-		      pjsip_TAG_STR;
+extern const pj_str_t pjsip_USER_STR,	    /**< "user" string constant.    */
+		      pjsip_METHOD_STR,	    /**< "method" string constant   */
+		      pjsip_TRANSPORT_STR,  /**< "transport" string const.  */
+		      pjsip_MADDR_STR,	    /**< "maddr" string const.	    */
+		      pjsip_LR_STR,	    /**< "lr" string const.	    */
+		      pjsip_SIP_STR,	    /**< "sip" string constant.	    */
+		      pjsip_SIPS_STR,	    /**< "sips" string constant.    */
+		      pjsip_TEL_STR,	    /**< "tel" string constant.	    */
+		      pjsip_BRANCH_STR,	    /**< "branch" string constant.  */
+		      pjsip_TTL_STR,	    /**< "ttl" string constant.	    */
+		      pjsip_RECEIVED_STR,   /**< "received" string const.   */
+		      pjsip_Q_STR,	    /**< "q" string constant.	    */
+		      pjsip_EXPIRES_STR,    /**< "expires" string constant. */
+		      pjsip_TAG_STR,	    /**< "tag" string constant.	    */
+		      pjsip_RPORT_STR;	    /**< "rport" string const.	    */
+
 
 /*
@@ -347,8 +360,4 @@
 void pjsip_parse_end_hdr_imp ( pj_scanner *scanner );
 
-/**
- * @}
- */
-
 PJ_END_DECL
 
Index: pjproject/trunk/pjsip/include/pjsip/sip_private.h
===================================================================
--- pjproject/trunk/pjsip/include/pjsip/sip_private.h	(revision 514)
+++ pjproject/trunk/pjsip/include/pjsip/sip_private.h	(revision 515)
@@ -27,19 +27,4 @@
 #include <pjsip/sip_types.h>
 
-PJ_BEGIN_DECL
-
-/**
- * @defgroup PJSIP_PRIVATE Private structures and functions (PJSIP internals)
- * @ingroup PJSIP
- * @{
- */
-
-
-
-/** 
- * @}
- */
-
-PJ_END_DECL
 
 #endif /* __PJSIP_PRIVATE_I_H__ */
Index: pjproject/trunk/pjsip/include/pjsip/sip_resolve.h
===================================================================
--- pjproject/trunk/pjsip/include/pjsip/sip_resolve.h	(revision 514)
+++ pjproject/trunk/pjsip/include/pjsip/sip_resolve.h	(revision 515)
@@ -33,7 +33,12 @@
 
 /**
- * @defgroup PJSIP_RESOLVE SIP Server Resolver
- * @ingroup PJSIP
+ * @defgroup PJSIP_RESOLVE Server Resolution
+ * @ingroup PJSIP_TRANSPORT
+ * @brief Framework to resolve SIP servers based on RFC 3263.
  * @{
+ * This is the server resolution framework, which is modelled after 
+ * RFC 3263 - Locating SIP Servers document. The server resolution
+ * framework is asynchronous; callback will be called once the server 
+ * address has been resolved (successfully or with errors).
  */
 
@@ -43,10 +48,8 @@
 #define PJSIP_MAX_RESOLVED_ADDRESSES	8
 
-typedef struct pjsip_server_addresses pjsip_server_addresses;
-
 /**
  * The server addresses returned by the resolver.
  */
-struct pjsip_server_addresses
+typedef struct pjsip_server_addresses
 {
     /** Number of address records. */
@@ -67,5 +70,6 @@
     } entry[PJSIP_MAX_RESOLVED_ADDRESSES];
 
-};
+} pjsip_server_addresses;
+
 
 /**
